--- old/usr/src/lib/libc/port/locale/localeimpl.c	Sat Jul  5 18:50:53 2014
+++ new/usr/src/lib/libc/port/locale/localeimpl.c	Sat Jul  5 18:50:53 2014
@@ -158,11 +158,11 @@
 {
 	struct locdata *ldata;
 
-	if ((ldata = calloc(1, sizeof (*ldata))) == NULL) {
+	if ((ldata = lmalloc(sizeof (*ldata))) == NULL) {
 		return (NULL);
 	}
-	if ((ldata->l_data[0] = calloc(1, memsz)) == NULL) {
-		free(ldata);
+	if ((ldata->l_data[0] = libc_malloc(memsz)) == NULL) {
+		lfree(ldata, sizeof (*ldata));
 		errno = ENOMEM;
 		return (NULL);
 	}
@@ -179,10 +179,10 @@
 __locdata_free(struct locdata *ldata)
 {
 	for (int i = 0; i < NLOCDATA; i++)
-		free(ldata->l_data[i]);
+		libc_free(ldata->l_data[i]);
 	if (ldata->l_map != NULL && ldata->l_map_len)
 		(void) munmap(ldata->l_map, ldata->l_map_len);
-	free(ldata);
+	lfree(ldata, sizeof (*ldata));
 }
 
 /*
@@ -250,7 +250,9 @@
 		lmutex_unlock(&cache_lock);
 		loc = (*loaders[category])(locname);
 		lmutex_lock(&cache_lock);
-		(void) strlcpy(loc->l_lname, locname, sizeof (loc->l_lname));
+		if (loc != NULL)
+			(void) strlcpy(loc->l_lname, locname,
+			    sizeof (loc->l_lname));
 	}
 
 	/*
@@ -260,7 +262,8 @@
 	 */
 	if (loc != NULL) {
 		cache_data[category] = loc;
-		if (loc->l_next == NULL) {
+		if (!loc->l_cached) {
+			loc->l_cached = 1;
 			loc->l_next = cat_data[category];
 			cat_data[category] = loc;
 		}
@@ -374,7 +377,7 @@
 	locale_t	loc;
 	int		i;
 
-	loc = calloc(1, sizeof (*loc));
+	loc = lmalloc(sizeof (*loc));
 	if (loc == NULL) {
 		return (NULL);
 	}
@@ -404,8 +407,8 @@
 	 * setlocale().  This shouldn't be strictly necessary, but a little
 	 * extra safety doesn't hurt here.
 	 */
-	if ((loc != &posix_locale) && (!loc->on_list))
-		free(loc);
+	if ((loc != NULL) && (loc != &posix_locale) && (!loc->on_list))
+		lfree(loc, sizeof (*loc));
 }
 
 locale_t
@@ -426,7 +429,7 @@
 	if (base == NULL || base == ___global_locale) {
 		loc = duplocale(___global_locale);
 	} else {
-		loc = base;
+		loc = duplocale(base);
 	}
 	if (loc == NULL) {
 		return (NULL);
@@ -455,6 +458,8 @@
 	loc->monetary = loc->locdata[LC_MONETARY]->l_data[0];
 	loc->numeric = loc->locdata[LC_NUMERIC]->l_data[0];
 	loc->time = loc->locdata[LC_TIME]->l_data[0];
+	freelocale(base);
+
 	return (mklocname(loc));
 }
 
